#include <linux/kmod.h>
#include "cfio_io.h"
#include "wlan_hotplug.h"

#if CONFIG_HOTPLUG

int wlan_run_sbin_hotplug(struct net_device *dev, char *action)
{
        char *argv[3], *envp[7], ifname[12 + IFNAMSIZ], action_str[32];
	char nsdname[32], wlan_wext[32];
        int i;

	if (dev) {
		sprintf(ifname, "INTERFACE=%s", dev->name);
		sprintf(nsdname, "NSDNAME=mcf25");
	} else {
		sprintf(ifname, "INTERFACE=null");
		sprintf(nsdname, "NSDNAME=null");
	}

	sprintf(wlan_wext, "WLAN_WEXT=");
	sprintf(action_str, "ACTION=%s", action);

	i = 0;
	argv[i++] = hotplug_path;
	argv[i++] = "wlan";
	argv[i] = NULL;

	i = 0;
	/* minimal command environment */
	envp [i++] = "HOME=/";
	envp [i++] = "PATH=/sbin:/bin:/usr/sbin:/usr/bin";
	envp [i++] = ifname;
	envp [i++] = action_str;
	envp [i++] = nsdname;
	envp [i++] = wlan_wext;
	envp [i] = NULL;
        
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,5,62)) 
	return call_usermodehelper(argv [0], argv, envp);
#else
	return call_usermodehelper(argv [0], argv, envp, 0);
#endif
}

#endif
